/*********************************************************************************************************
**--------------File Info---------------------------------------------------------------------------------
** File name:           IRQ_RIT.c
** Last modified Date:  2014-09-25
** Last Version:        V1.00
** Descriptions:        functions to manage T0 and T1 interrupts
** Correlated files:    RIT.h
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
#include "lpc17xx.h"
#include "RIT.h"
#include "../led/led.h"
#include "../timer/timer.h"
#include "../semaphore/semaphore.h"


/******************************************************************************
** Function name:		RIT_IRQHandler
**
** Descriptions:		REPETITIVE INTERRUPT TIMER handler
**
** parameters:			None
** Returned value:		None
**
******************************************************************************/

int down=0;

void RIT_IRQHandler (void)
{					
	
	/* button management */
	if(down!=0 && getManteinanceState() == 0 ){ 
		if((LPC_GPIO2->FIOPIN & (1<<10)) == 0){	/* KEY0 pressed */
				setSpeakerSound(1);
		}else {	/* button released */
			down=0;		
			setSpeakerSound(0);
			NVIC_EnableIRQ(EINT0_IRQn);							 /* enable Button interrupts			*/
			LPC_PINCON->PINSEL4    |= (1 << 20);     /* External interrupt 0 pin selection */
		}
	}
		
	/* joystick management */
	if((LPC_GPIO1->FIOPIN & (1<<28)) == 0){	/* Joytick Select pressed */
		setManteinanceState();
	}else 	if((LPC_GPIO1->FIOPIN & (1<<27)) == 0){
		initialState();
	}
	
	if(getManteinanceState() == 1){ 
			/* ADC management */
			ADC_start_conversion(); //
	}
	

				
			
  LPC_RIT->RICTRL |= 0x1;	/* clear interrupt flag */
}

/******************************************************************************
**                            End Of File
******************************************************************************/
