#include "button.h"
#include "lpc17xx.h"

#include "../led/led.h"
#include "../timer/timer.h"

volatile int buttonPressed = 0;
volatile int blindPressed = 0;

extern int sound;
extern int down;

int getButtonPressed(void){
return buttonPressed;
}

void clearButtonPressed(void){
		buttonPressed = 0;
		blindPressed = 0;
}

int getBlindButtonPressed(void){
	 return blindPressed;
}


void EINT0_IRQHandler (void)	  	/* INT0	pin 10												 */
{
	NVIC_DisableIRQ(EINT0_IRQn);		/* disable Button interrupts		*/
	LPC_PINCON->PINSEL4    &= ~(1 << 20);     /* GPIO pin selection */
	
	sound = 1;
	down=1;
	buttonPressed = 1;
	blindPressed = 1;
	LPC_SC->EXTINT &= (1 << 0);     /* clear pending interrupt         */
}


void EINT1_IRQHandler (void)	  	/* KEY1	pin 11												 */
{
	buttonPressed = 1;
	LPC_SC->EXTINT &= (1 << 1);     /* clear pending interrupt         */
}

void EINT2_IRQHandler (void)	  	/* KEY2		pin 12												 */
{
	buttonPressed = 1;
  LPC_SC->EXTINT &= (1 << 2);     /* clear pending interrupt         */    
}


