#include "semaphore.h"
#include "../led/led.h"
#include <stdio.h>
#include "LPC17xx.H"  
#include "../button_EXINT/button.h"
#include "../timer/timer.h"
#include "../RIT/RIT.h"


#define second  25000000  
#define halfSecond second/2

volatile int sound = 0;
volatile int myState = 0;

void setManteinanceState(void){
	if(myState == 0){
		myState = 4;
	}
}

int getManteinanceState(){
	return myState == 4;
}

void initialState(void){
	if(myState == 4){
		myState = 0;
		setSpeakerSound(0);
	}
}


int j = 0;

void semaphore(){
			
		int i = 0;	
		switch (myState){
			case 0: // green pedastrian
				
				LED_Out(0x60); //01100000		
				
				sound = getBlindButtonPressed();
				clearButtonPressed(); // clear flag of pending button pressed 
				    								  //so, I stay in this state only for the request time in case of two buttons are pressed		
				
				for(i = 0; i<7 & myState == 0; i++){
					setSpeakerSound(0);
					waitfor(second); 
					setSpeakerSound(sound); //sets sound only if blind's button sets sound to 1
					waitfor(second);
					
					if(getButtonPressed() == 1 & myState == 0){
						i = 0;
						clearButtonPressed();
					}
				}
				
				setSpeakerSound(0);
				
				if(myState == 0)// no other function set mystate to other value
					nextState();	
				
			break;
			
			case 1: // green pedastrians blinking
				
				LED_Out(0x60); //01100000
				nextState();
				
					for( i = 0; i < 5; i++){
						LED_Off(6); // green pedastrians off
						setSpeakerSound(0);
						waitfor(halfSecond);
						if(getButtonPressed()==1){// if i press the button I force state = 0;
								myState = 0;
								break;
						}
						LED_On(6); // green pedastrians on
						setSpeakerSound(sound);
						waitfor(halfSecond);		
						if(getButtonPressed()==1){// if i press the button I force state = 0;
								myState = 0;
								break;
						}
					}
			break;
			
			case 2: // red pedastrians
						sound = 0;
						setSpeakerSound(sound);
						LED_Out(0x88); //10001000
						nextState();
					
						while(getButtonPressed() == 0){
								__ASM("wfi"); // wait for interrupt
						}
						
						waitForTimerEnd( 5 * second);// pedestrians can't skip waiting by sending interrupts and wake up the processor						
			break;
			
						
			case 3: // yellow car
				LED_Out(0x90); //10010000
				nextState();
				waitForTimerEnd( 5 * second);// pedestrians can't skip waiting by sending interrupts and wake up the processor

			break;
			
			case 4: //Manteinance

					enable_timer(0);
					
					setSpeakerSound(1); //sets sound only if blind's button sets sound to 1
					LED_Out(0x90); //10010000
			
			
					//wonderfull music	


					for(j = 0; j<4; j++){
						init_timer(0,2120); 
						waitForTimerEnd(second/16); 
						init_timer(0,1684); 
						waitForTimerEnd(second/16); 
						init_timer(0,1417); 
						waitForTimerEnd(second/16); 
						init_timer(0,1062); 
						waitForTimerEnd(second/16);
						
					}
					
			    //try end
					setSpeakerSound(0);
					LED_Out(0x00); //00000000
					waitForTimerEnd(second); 
			
			
			break;
			
		}//end case	
}

void waitfor(int tiks){ // wait for interrupt and set timer
		reset_timer(1);
		init_timer(1, tiks);
		enable_timer(1);
		while(getButtonPressed() == 0 & timerStatus() == 1)// wait until timer finished or interruption from buttons
			__ASM("wfi");
		disable_timer(1);
}

void waitForTimerEnd(int tiks){
	reset_timer(1);
	init_timer(1, tiks);
	enable_timer(1); // wait for timer				
	while(timerStatus() == 1){ //while timer is runnig, no mather of other interrupt
		__ASM("wfi");
	}// pedestrians can't skip waiting by sending interrupts and wake up the processor
	
}


void nextState(){ //modify mystate to nextstate
	switch (myState){
		case 0: // green pedastrians
				myState = 1;
		break;
		
		case 1: // green blinking pedastrians
				myState = 2;
		break;
		
		case 2: // red pedastrians
			myState = 3;
		break;
		
		case 3: // yellow pedastrians
			myState = 0;
		break;		
	}
		
}

